---
title: CanvasRenderingContext2D.drawWindow()
slug: Web/API/CanvasRenderingContext2D/drawWindow
tags:
  - API
  - Canvas
  - CanvasRenderingContext2D
  - Method
  - Non-standard
  - Reference
---
<div>{{APIRef}} {{deprecated_header}}</div>

<p>The deprecated, non-standard and internal only <code><strong>CanvasRenderingContext2D</strong></code><strong><code>.drawWindow()</code></strong> method of the Canvas 2D API renders a region of a window into the <code>canvas</code>. The contents of the window's viewport are rendered, ignoring viewport clipping and scrolling.</p>

<p>This API cannot be used by Web content. It is synchronous, and as such can't capture cross-origin (out of process) iframes with Fission.  If you're using it from an extension, you should switch to {{WebExtAPIRef('tabs.captureTab')}}.  If you're writing chrome code, you probably want <a href="https://searchfox.org/mozilla-central/rev/9b282b34b5/dom/chrome-webidl/WindowGlobalActors.webidl#81-98">WindowGlobalParent.drawSnapshot</a> from the parent process.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">void <em>ctx</em>.drawWindow(<em>window</em>, <em>x</em>, <em>y</em>, <em>w</em>, <em>h</em>, <em>bgColor</em> [, <em>flags</em>]);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>window</code></dt>
 <dd>The {{domxref("Window")}} to render.</dd>
 <dt><code>x</code></dt>
 <dd>The x-axis coordinate of the window.</dd>
 <dt><code>y</code></dt>
 <dd>The y-axis coordinate of the window.</dd>
 <dt><code>w</code></dt>
 <dd>The width of the window.</dd>
 <dt><code>h</code></dt>
 <dd>The height of the window.</dd>
 <dt><code>bgColor</code></dt>
 <dd>A {{domxref("DOMString")}} that specifies the color the canvas is filled with before the window is rendered into it. This color may be transparent/translucent. It is given as a CSS color string (for example, <code>rgb()</code> or <code>rgba()</code>).<br>
 Notes:
 <ul>
  <li>If "<code>rgba(0,0,0,0)</code>" is used for the background color, the drawing will be transparent wherever the window is transparent.</li>
  <li>Top-level browsed documents are usually not transparent because the user's background-color preference is applied, but {{HTMLElement("iframe", "iframes")}} are transparent if the page doesn't set a background.</li>
  <li>If an opaque color is used for the background color, rendering will be faster because we won't have to compute the window's transparency.</li>
 </ul>
 </dd>
 <dt><code>flags</code> {{optional_inline}}</dt>
 <dd>Used to better control the <code>drawWindow</code> call. Flags can be ORed together.
 <table class="standard-table">
  <tbody>
   <tr>
    <td class="header">Constant</td>
    <td class="header">Value</td>
    <td class="header">Description</td>
   </tr>
   <tr>
    <td><code>DRAWWINDOW_DRAW_CARET</code></td>
    <td><code>0x01</code></td>
    <td>Show the caret if appropriate when drawing.</td>
   </tr>
   <tr>
    <td><code>DRAWWINDOW_DO_NOT_FLUSH</code></td>
    <td><code>0x02</code></td>
    <td>Do not flush pending layout notifications that could otherwise be batched up.</td>
   </tr>
   <tr>
    <td><code>DRAWWINDOW_DRAW_VIEW</code></td>
    <td><code>0x04</code></td>
    <td>Draw scrollbars and scroll the viewport if they are present.</td>
   </tr>
   <tr>
    <td><code>DRAWWINDOW_USE_WIDGET_LAYERS</code></td>
    <td><code>0x08</code></td>
    <td>Use the widget layer manager if available. This means hardware acceleration may be used, but it might actually be slower or lower quality than normal. It will, however, more accurately reflect the pixels rendered to the screen.</td>
   </tr>
   <tr>
    <td><code>DRAWWINDOW_ASYNC_DECODE_IMAGES</code></td>
    <td><code>0x10</code></td>
    <td>Do not synchronously decode images - draw what we have.</td>
   </tr>
  </tbody>
 </table>
 </dd>
</dl>

<h2 id="Example">Example</h2>

<p>This method draws a snapshot of the contents of a DOM <code>window</code> into the canvas. For example,</p>

<pre class="brush: js notranslate">ctx.drawWindow(window, 0, 0, 100, 200, 'rgb(255,255,255)');
</pre>

<p>... would draw the contents of the current window, in the rectangle (0,0,100,200) in pixels relative to the top-left of the viewport, on a white background, into the canvas. By specifying "<code>rgba(255,255,255,0)</code>" as the color, the contents would be drawn with a transparent background (which would be slower).</p>

<p>It is usually a bad idea to use any background other than pure white "<code>rgb(255,255,255)</code>" or transparent, as this is what all browsers do, and many websites expect that transparent parts of their interface will be drawn on white background.</p>

<p>With this method, it is possible to fill a hidden IFRAME with arbitrary content (e.g., CSS-styled HTML text, or SVG) and draw it into a canvas. It will be scaled, rotated and so on according to the current transformation.</p>

<p>Ted Mielczarek's <a class="external external-icon" href="http://ted.mielczarek.org/code/mozilla/tabpreview/">tab preview</a> extension uses this technique in chrome to provide thumbnails of web pages, and the source is available for reference.</p>

<h2 id="Specifications">Specifications</h2>

<p>Not part of any current specification or draft. This is a non-standard and internal only API.</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CanvasRenderingContext2D.drawWindow")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The interface defining this method: {{domxref("CanvasRenderingContext2D")}}</li>
 <li>{{domxref("CanvasRenderingContext2D.drawWidgetAsOnScreen()")}}</li>
</ul>
